SystemOrganization addCategory: #'Scripting-Examples'!
SystemOrganization addCategory: #'Scripting-Infrastructure'!

Object subclass: #HelloWorld
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scripting-Examples'!

!HelloWorld class methodsFor: 'script entry' stamp: ''!
run: arguments 
	RVMTester print: 'Hello World!!'.
	arguments
		do: [:elem | RVMTester print: elem].
	SmalltalkImage current snapshot: false andQuit: true! !

Object subclass: #ScriptStarter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scripting-Infrastructure'!

!ScriptStarter class methodsFor: 'system startup entry' stamp: 'StefanMarr 10/14/2009 13:27'!
addToStartupList
	"Needs to be called after fileing in this code and activate the ScriptStarter on VM startup
	
	 Do: ScriptStarter addToStartupList
	"
	Smalltalk addToStartUpList: ScriptStarter! !

!ScriptStarter class methodsFor: 'helper' stamp: 'StefanMarr 10/14/2009 17:38'!
executeRunFor: scriptClassName with: arguments
	| scriptClass |
	
	scriptClass := Smalltalk classNamed: scriptClassName.
	scriptClass ifNotNilDo: [:sc | scriptClass run: arguments].! !

!ScriptStarter class methodsFor: 'helper' stamp: ''!
getSystemAttributes
	| arguments arg i |
	arguments := OrderedCollection new.
	i := 2.
	[[arg := SmalltalkImage current getSystemAttribute: i] value == nil]
		whileFalse: [arguments addLast: arg.
			i := i + 1].
	^ arguments! !

!ScriptStarter class methodsFor: 'system startup entry' stamp: 'StefanMarr 10/14/2009 17:41'!
startUp
	"startUp is invoked during startup.
	 ScriptStarter has to be registered in the SystemDirectory's StartUpList
	 See ScriptStarter>>addToStartupList"
	
	| arguments scriptClassName |
	arguments := self getSystemAttributes.
	arguments size > 0
		ifTrue: [scriptClassName := arguments at: 1.
			self executeRunFor: scriptClassName with: arguments.]! !
